using System;
using System.Collections.Generic;
using System.Text;

using gudusoft.gsqlparser;
using gudusoft.gsqlparser.Units;

namespace orderbyClause
{
    class orderbyClause
    {
        static void Main(string[] args)
        {
            TGSqlParser sqlparser = new TGSqlParser(TDbVendor.DbVMssql);
            sqlparser.SqlText.Text = @"SELECT ClientID, FirstName + ' ' + LastName AS FullName, Phone
FROM Client
WHERE ClientID IN ( 1, 2, 3, 4 )
";
            int iRet = sqlparser.Parse();
            TSelectSqlStatement select = (TSelectSqlStatement)sqlparser.SqlStatements[0];
            modifyOrderbyClause(select, "ClientID ASC");
            Console.WriteLine(pp(select.AsText, TDbVendor.DbVMssql));

            sqlparser.SqlText.Text = @"SELECT top 4 ClientID, FirstName + ' ' + LastName AS FullName, Phone
FROM Client
WHERE ClientID IN ( 1, 2, 3, 4 ) order by ClientName Desc
";
            iRet = sqlparser.Parse();
            select = (TSelectSqlStatement)sqlparser.SqlStatements[0];
            modifyOrderbyClause(select, "ClientID ASC");
            Console.WriteLine(pp(select.AsText, TDbVendor.DbVMssql));


        }

        /// <summary>
        /// 
        /// add new order by clause if there is no order by clause in select already, 
        /// otherwise, just ignore new order by clause.
        /// </summary>
        /// <param name="select"></param>
        /// <param name="newstr"></param>
        static void modifyOrderbyClause(TSelectSqlStatement select, string newstr)
        {
            if (select.SortClause == null)
            {
                select.SortClauseText = newstr;
            }
        }

        static string pp(string sql, TDbVendor vendor)
        {
            TGSqlParser parser = new TGSqlParser(vendor);
            parser.SqlText.Text = sql;
            if (parser.PrettyPrint() == 0)
            {
                return parser.FormattedSqlText.Text;
            }
            else
            {
                return sql;
            }

        }
    }
}
